<template>
  <div class="py-8">
    <nav class="bg-gray-800 fixed inset-x-0 top-0 z-50">
      <div class="max-w-7xl mx-auto px-2 sm:px-6 lg:px-16 left-0 right-0">
        <div class="relative flex items-center justify-between h-16">
          <div class="absolute inset-y-0 left-0 flex items-center sm:hidden">
            <!-- Mobile menu button-->
            <button
              @click="isOpen = !isOpen"
              type="button"
              class="inline-flex items-center justify-center p-2 rounded-md text-gray-400 hover:text-white hover:bg-gray-700 focus:outline-none focus:ring-2 focus:ring-inset focus:ring-white"
              aria-controls="mobile-menu"
              aria-expanded="false"
            >
              <span class="sr-only">Open main menu</span>
              <!--
            Icon when menu is closed.

            Heroicon name: outline/menu

            Menu open: "hidden", Menu closed: "block"
          -->
              <svg
                :class="!isOpen ? 'block h-6 w-6' : 'hidden'"
                xmlns="http://www.w3.org/2000/svg"
                fill="none"
                viewBox="0 0 24 24"
                stroke="currentColor"
                aria-hidden="true"
              >
                <path
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  stroke-width="2"
                  d="M4 6h16M4 12h16M4 18h16"
                />
              </svg>
              <!--
            Icon when menu is open.

            Heroicon name: outline/x

            Menu open: "block", Menu closed: "hidden"
          -->
              <svg
                :class="isOpen ? 'block h-6 w-6' : 'hidden'"
                xmlns="http://www.w3.org/2000/svg"
                fill="none"
                viewBox="0 0 24 24"
                stroke="currentColor"
                aria-hidden="true"
              >
                <path
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  stroke-width="2"
                  d="M6 18L18 6M6 6l12 12"
                />
              </svg>
            </button>
          </div>
          <div class="flex-1 flex items-center justify-center sm:items-stretch sm:justify-start">
            <div class="flex-shrink-0 flex items-center">
              <router-link to="/">
                <img
                  class="block lg:hidden h-8 w-auto"
                  src="../assets/Bookedex-text.png"
                  alt="Bookedex"
                />
                <img
                  class="hidden lg:block h-8 w-auto"
                  src="../assets/Bookedex-text.png"
                  alt="Bookedex"
                />
              </router-link>
            </div>
            <div class="hidden sm:block sm:ml-6">
              <div class="flex space-x-4">
                <!-- Current: "bg-gray-900 text-white", Default: "text-gray-300 hover:bg-gray-700 hover:text-white" -->
                <router-link
                  tag="li"
                  to="/"
                  class="text-gray-300 hover:bg-gray-700 hover:text-white px-3 py-2 rounded-md text-sm font-medium"
                  aria-current="page"
                  >Accueil</router-link
                >

                <router-link
                  tag="li"
                  to="/search"
                  class="text-gray-300 hover:bg-gray-700 hover:text-white px-3 py-2 rounded-md text-sm font-medium"
                  >Rechercher</router-link
                >

                <router-link
                  tag="li"
                  to="/scan-a-book"
                  class="text-gray-300 hover:bg-gray-700 hover:text-white px-3 py-2 rounded-md text-sm font-medium"
                  >Scanner un livre</router-link
                >
              </div>
            </div>
          </div>
          <div
            v-if="userIsCo"
            class="absolute inset-y-0 right-0 flex items-center pr-2 sm:static sm:inset-auto sm:ml-6 sm:pr-0"
          >
            <!-- Profile dropdown -->
            <div class="ml-3 relative">
              <div>
                <button
                  @click="isOpenUserMenu = !isOpenUserMenu"
                  type="button"
                  class="bg-gray-800 flex text-sm rounded-full focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-offset-gray-800 focus:ring-white"
                  id="user-menu-button"
                  aria-expanded="false"
                  aria-haspopup="true"
                >
                  <span class="sr-only">Menu utilisateur</span>
                  <img
                    class="h-8 w-8 rounded-full"
                    :src="
                      user.photoURL
                        ? user.photoURL
                        : 'https://akns-images.eonline.com/eol_images/Entire_Site/2021619/rs_1200x1200-210719101259-1200-kanye-west.cm.71921.jpg?fit=around%7C1080:1080&output-quality=90&crop=1080:1080;center,top'
                    "
                    alt=""
                  />
                </button>
              </div>

              <!--
            Dropdown menu, show/hide based on menu state.

            Entering: "transition ease-out duration-100"
              From: "transform opacity-0 scale-95"
              To: "transform opacity-100 scale-100"
            Leaving: "transition ease-in duration-75"
              From: "transform opacity-100 scale-100"
              To: "transform opacity-0 scale-95"
          -->
              <div
                :class="
                  isOpenUserMenu
                    ? 'block origin-top-right absolute right-0 mt-2 w-48 rounded-md shadow-lg py-1 bg-white ring-1 ring-black ring-opacity-5 focus:outline-none'
                    : 'hidden'
                "
                @click="isOpenUserMenu = !isOpenUserMenu"
                role="menu"
                aria-orientation="vertical"
                aria-labelledby="user-menu-button"
                tabindex="-1"
              >
                <router-link
                  tag="li"
                  to="/my-books"
                  class="block px-4 py-2 text-sm text-gray-700"
                  role="menuitem"
                  tabindex="-1"
                  >Mes livres</router-link
                >
                <!-- Active: "bg-gray-100", Not Active: "" -->
                <router-link
                  tag="li"
                  to="/my-profile"
                  class="block px-4 py-2 text-sm text-gray-700"
                  role="menuitem"
                  tabindex="-1"
                  id="user-menu-item-0"
                  >Mon profil</router-link
                >
                <a
                  href="#"
                  @click="logOut()"
                  class="block px-4 py-2 text-sm text-gray-700"
                  role="menuitem"
                  tabindex="-1"
                  id="user-menu-item-2"
                  >Déconnexion</a
                >
              </div>
            </div>
          </div>
          <div
            v-else
            class="absolute inset-y-0 right-0 flex items-center pr-2 sm:static sm:inset-auto sm:ml-6 sm:pr-0"
          >
            <!-- Profile dropdown -->
            <div class="ml-3 relative">
              <div>
                <button
                  @click="isOpenUserMenu = !isOpenUserMenu"
                  type="button"
                  class="bg-gray-800 flex text-sm rounded-full focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-offset-gray-800 focus:ring-white"
                  id="user-menu-button"
                  aria-expanded="false"
                  aria-haspopup="true"
                >
                  <span class="sr-only">Menu connexion</span>
                  <img class="h-8 w-8 rounded-full" src="../assets/user.png" alt="Non connecté" />
                </button>
              </div>

              <div
                :class="
                  isOpenUserMenu
                    ? 'block origin-top-right absolute right-0 mt-2 w-72 rounded-md shadow-lg py-1 bg-white ring-1 ring-black ring-opacity-5 focus:outline-none'
                    : 'hidden'
                "
                role="menu"
                aria-orientation="vertical"
                aria-labelledby="user-menu-button"
                tabindex="-1"
              >
                <!-- Active: "bg-gray-100", Not Active: "" -->

                <a
                  @click="openConnexion()"
                  href="#"
                  class="block px-4 py-2 text-sm text-gray-700"
                  role="menuitem"
                  tabindex="-1"
                  id="user-menu-item-0"
                  >Me connecter</a
                >
                <SignIn v-if="isConnexion" @custom-event-user-co="setConnection" />
                <a
                  @click="openInscription()"
                  href="#"
                  class="block px-4 py-2 text-sm text-gray-700"
                  role="menuitem"
                  tabindex="-1"
                  id="user-menu-item-2"
                  >M'inscrire</a
                >
                <SignUp v-if="isInscription" @custom-event-user-regist="setConnection" />
              </div>
            </div>
          </div>
        </div>
      </div>

      <!-- Mobile menu, show/hide based on menu state. -->
      <div :class="isOpen ? 'block' : 'hidden'" id="mobile-menu">
        <div @click="isOpen = !isOpen" class="px-2 pt-2 pb-3 space-y-1">
          <!-- Current: "bg-gray-900 text-white", Default: "text-gray-300 hover:bg-gray-700 hover:text-white" -->
          <router-link
            tag="li"
            to="/"
            class="text-gray-300 hover:bg-gray-700 hover:text-white block px-3 py-2 rounded-md text-base font-medium"
            aria-current="page"
            >Accueil</router-link
          >

          <router-link
            tag="li"
            to="/search"
            class="text-gray-300 hover:bg-gray-700 hover:text-white block px-3 py-2 rounded-md text-base font-medium"
            >Rechercher</router-link
          >

          <router-link
            tag="li"
            to="/scan-a-book"
            class="text-gray-300 hover:bg-gray-700 hover:text-white block px-3 py-2 rounded-md text-base font-medium"
            >Scanner un livre</router-link
          >
        </div>
      </div>
    </nav>
  </div>
</template>
<script>
import { isConnected, getCurrentUser, signOut } from "../services/authenticationService";
import SignUp from "./SignUp";
import SignIn from "./SignIn";
export default {
  name: "Header",
  components: {
    SignUp,
    SignIn,
  },
  data() {
    return {
      isOpen: false,
      isOpenUserMenu: false,
      userIsCo: undefined,
      isInscription: false,
      isConnexion: false,
      user: null,
      search: "",
    };
  },
  methods: {
    openInscription() {
      if (this.isConnexion) {
        this.isConnexion = !this.isConnexion;
      }
      this.isInscription = !this.isInscription;
    },

    openConnexion() {
      if (this.isInscription) {
        this.isInscription = !this.isInscription;
      }
      this.isConnexion = !this.isConnexion;
    },
    async logOut() {
      this.userIsCo = signOut();
      this.isOpenUserMenu = false;
    },

    searcher() {
      this.$emit("search-event", { search: this.search.replace("-", "") });
    },
    async setConnection(payload) {
      this.userIsCo = payload.userIsCo;
      this.isOpenUserMenu = false;
      this.user = await getCurrentUser();
    },
  },
  async created() {
    // eslint-disable-next-line no-unused-vars
    this.userIsCo = await isConnected();
    if (this.userIsCo) {
      this.user = await getCurrentUser();
    }
  },
};
</script>
<style>
div li.router-link-active {
  background-color: #111827;
  color: white;
}
input,
textarea,
button,
select,
a {
  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}
</style>
